/*
 *    paperease: a driver for the Primax Paperease scanner
 *    (c) 2002 James McKenzie <james@fishsoup.dhs.org>. 
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License , or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program. If not, write to the Free Software
 *    Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 *    This program was produced by running the windows drivers
 *    for the program and recording all accesses to the parallel
 *    port circuitry passing the results through awk, sed and uniq.
 *
 *    Take care not to quit this program except by using 
 *    SIGINT - doing do may burn out the motor on your 
 *    scanner.
 *
 */
/*
 * calib.c:
 *
 * Copyright (c) 2002 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] = "$Id: calib.c,v 1.10 2002/05/19 15:56:36 root Exp $";

/*
 * $Log: calib.c,v $
 * Revision 1.10  2002/05/19 15:56:36  root
 * *** empty log message ***
 *
 * Revision 1.9  2002/05/19 15:21:05  root
 * *** empty log message ***
 *
 * Revision 1.8  2002/05/19 15:20:59  root
 * *** empty log message ***
 *
 * Revision 1.7  2002/05/19 10:50:06  root
 * *** empty log message ***
 *
 * Revision 1.6  2002/05/18 16:52:48  root
 * *** empty log message ***
 *
 * Revision 1.5  2002/05/18 16:52:44  root
 * *** empty log message ***
 *
 * Revision 1.4  2002/05/18 16:52:41  root
 * *** empty log message ***
 *
 * Revision 1.3  2002/05/18 16:52:39  root
 * *** empty log message ***
 *
 * Revision 1.2  2002/05/18 16:33:42  root
 * *** empty log message ***
 *
 * Revision 1.1  2002/05/18 16:33:26  root
 * Initial revision
 *
 */


unsigned char calib[2548] = {
  14, 20, 17, 9, 3, 1, 0, 0, 0, 0,
  1, 7, 15, 14, 5, 1, 0, 0, 0, 0,
  0, 0, 3, 9, 7, 0, 0, 0, 0, 0,
  0, 0, 0, 1, 2, 1, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 3, 3, 0,
  0, 0, 0, 0, 0, 0, 0, 1, 1, 1,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 1, 1, 0, 0, 0, 0,
  0, 0, 0, 0, 1, 1, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 2, 2, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 4, 5, 0,
  0, 0, 0, 0, 0, 0, 1, 8, 18, 16,
  5, 1, 0, 0, 0, 0, 1, 5, 14, 21,
  16, 5, 1, 0, 0, 0, 0, 2, 9, 19,
  27, 20, 8, 3, 1, 1, 2, 3, 8, 15,
  26, 28, 16, 5, 1, 0, 0, 0, 3, 8,
  18, 31, 30, 16, 8, 5, 2, 1, 5, 9,
  14, 24, 30, 25, 14, 6, 4, 3, 5, 7,
  14, 23, 33, 40, 35, 26, 18, 14, 14, 15,
  17, 25, 32, 39, 45, 39, 27, 19, 14, 13,
  13, 18, 26, 34, 45, 50, 42, 31, 22, 16,
  13, 12, 15, 21, 29, 39, 41, 28, 17, 12,
  10, 10, 11, 15, 22, 33, 42, 42, 31, 21,
  15, 14, 14, 14, 19, 28, 36, 43, 43, 36,
  32, 29, 27, 24, 24, 29, 35, 43, 49, 48,
  41, 35, 32, 32, 32, 35, 40, 48, 58, 61,
  56, 49, 39, 32, 33, 31, 28, 31, 38, 48,
  50, 41, 32, 26, 22, 22, 24, 27, 32, 43,
  52, 52, 44, 37, 33, 29, 27, 27, 30, 37,
  47, 55, 54, 46, 40, 37, 36, 33, 35, 40,
  47, 56, 62, 58, 47, 41, 40, 38, 34, 37,
  43, 50, 60, 66, 62, 53, 47, 44, 40, 40,
  43, 47, 53, 62, 67, 64, 55, 50, 48, 46,
  46, 46, 49, 58, 66, 72, 68, 60, 56, 53,
  53, 52, 52, 55, 61, 69, 71, 63, 55, 49,
  49, 49, 49, 50, 56, 65, 75, 78, 68, 60,
  59, 56, 52, 52, 54, 59, 64, 69, 68, 59,
  53, 50, 49, 49, 51, 56, 62, 69, 76, 70,
  60, 55, 51, 50, 51, 53, 55, 58, 65, 69,
  66, 60, 54, 50, 50, 51, 55, 60, 65, 71,
  74, 70, 63, 58, 55, 53, 53, 56, 59, 62,
  68, 69, 63, 58, 52, 50, 55, 58, 58, 61,
  68, 73, 71, 66, 60, 56, 53, 50, 52, 53,
  56, 63, 70, 69, 62, 58, 54, 50, 50, 52,
  53, 58, 65, 73, 75, 67, 62, 58, 55, 54,
  57, 61, 68, 76, 76, 66, 63, 60, 54, 50,
  51, 52, 52, 57, 64, 64, 56, 48, 42, 39,
  40, 42, 43, 45, 50, 57, 59, 52, 43, 38,
  35, 32, 32, 36, 43, 52, 57, 52, 41, 34,
  31, 30, 29, 29, 32, 37, 43, 47, 43, 31,
  24, 20, 16, 15, 19, 23, 28, 36, 45, 44,
  35, 28, 26, 26, 28, 30, 34, 40, 49, 55,
  50, 40, 34, 31, 28, 25, 27, 32, 40, 47,
  48, 40, 31, 24, 18, 15, 14, 16, 24, 32,
  40, 43, 36, 28, 20, 13, 9, 8, 15, 22,
  24, 29, 32, 20, 7, 3, 2, 1, 2, 5,
  8, 17, 23, 17, 7, 2, 1, 1, 0, 1,
  3, 6, 15, 22, 17, 8, 2, 1, 1, 1,
  1, 4, 11, 16, 17, 10, 2, 1, 1, 0,
  0, 0, 2, 5, 10, 10, 5, 0, 0, 0,
  0, 0, 0, 0, 2, 4, 4, 1, 0, 0,
  0, 0, 0, 0, 0, 0, 2, 2, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 3, 3, 0,
  0, 0, 0, 0, 0, 0, 0, 2, 5, 4,
  0, 0, 0, 0, 0, 0, 0, 4, 13, 13,
  4, 0, 0, 0, 0, 0, 0, 0, 1, 4,
  4, 2, 0, 0, 0, 0, 0, 0, 0, 1,
  3, 5, 2, 0, 0, 0, 0, 0, 0, 0,
  2, 5, 5, 1, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 1, 1, 0, 0, 0, 0,
  0, 0, 1, 2, 5, 6, 3, 0, 0, 0,
  0, 0, 0, 0, 2, 7, 9, 4, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  2, 2, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 6, 5, 1, 0, 0, 0, 0, 0, 0,
  0, 1, 5, 4, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 1, 1, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 1, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 1, 4, 4, 1, 0,
  0, 0, 0, 0, 0, 0, 1, 2, 2, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
  1, 0, 0, 0, 0, 0, 0, 0, 1, 3,
  10, 12, 5, 1, 0, 0, 0, 0, 0, 1,
  5, 9, 6, 0, 0, 0, 0, 0, 0, 0,
  0, 2, 4, 3, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 1, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 2, 1, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 1, 1, 0, 0, 0, 0, 0, 0, 0,
  0, 1, 2, 1, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 1, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 2, 3, 1, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 2, 2, 0,
  0, 0, 0, 0, 0, 0, 0, 1, 2, 1,
  0, 0, 0, 0, 0, 0, 0, 0, 2, 2,
  1, 0, 0, 0, 0, 0, 0, 0, 0, 1,
  1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 1, 1, 0, 0, 0, 0, 0, 0, 0,
  3, 10, 8, 1, 0, 0, 0, 0, 0, 0,
  0, 2, 5, 3, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 1, 1, 0, 0, 0, 0, 0,
  0, 0, 0, 2, 2, 1, 0, 0, 0, 0,
  0, 0, 0, 0, 1, 1, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
  0, 0, 0, 0, 0, 3, 12, 19, 12, 3,
  0, 0, 0, 0, 0, 0, 0, 1, 1, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
  1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 1, 1, 0,
  0, 0, 0, 0, 0, 0, 0, 1, 1, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 1, 1, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0
};
